---
title: Console.table()
slug: Web/API/Console/table
tags:
  - API
  - DOM
  - Debugging
  - Method
  - Web Development
  - web console
---
<div>{{APIRef("Console API")}}</div>

<p><span class="seoSummary">Displays tabular data as a table.</span></p>

<p>This function takes one mandatory argument <code>data</code>, which must be an array or an object, and one additional optional parameter <code>columns</code>.</p>

<p>It logs <code>data</code> as a table. Each element in the array (or enumerable property if <code>data</code> is an object) will be a row in the table.</p>

<p>The first column in the table will be labeled <code>(index)</code>. If <code>data</code> is an array, then its values will be the array indices. If <code>data</code> is an object, then its values will be the property names. Note that (in Firefox) <code>console.table</code> is limited to displaying 1000 rows (first row is the labeled index).</p>

<p>{{AvailableInWorkers}}</p>

<h3 id="Collections_of_primitive_types">Collections of primitive types</h3>

<p>The <code>data</code> argument may be an array or an object.</p>

<pre class="brush: js">// an array of strings

console.table(["apples", "oranges", "bananas"]);</pre>

<p><img alt="" src="https://mdn.mozillademos.org/files/8567/console-table-array.png"></p>

<pre class="brush: js">// an object whose properties are strings

function Person(firstName, lastName) {
  this.firstName = firstName;
  this.lastName = lastName;
}

var me = new Person("John", "Smith");

console.table(me);</pre>

<p><img alt="" src="https://mdn.mozillademos.org/files/8559/console-table-simple-object.png"></p>

<h3 id="Collections_of_compound_types">Collections of compound types</h3>

<p>If the elements in the array, or properties in the object, are themselves arrays or objects, then their elements or properties are enumerated in the row, one per column:</p>

<pre class="brush: js">// an array of arrays

var people = [["John", "Smith"], ["Jane", "Doe"], ["Emily", "Jones"]]
console.table(people);</pre>

<p><img alt="Table displaying array of arrays" src="https://mdn.mozillademos.org/files/8561/console-table-array-of-array.png"></p>

<pre class="brush: js">// an array of objects

function Person(firstName, lastName) {
  this.firstName = firstName;
  this.lastName = lastName;
}

var john = new Person("John", "Smith");
var jane = new Person("Jane", "Doe");
var emily = new Person("Emily", "Jones");

console.table([john, jane, emily]);</pre>

<p>Note that if the array contains objects, then the columns are labeled with the property name.</p>

<p><img alt="Table displaying array of objects" src="https://mdn.mozillademos.org/files/8563/console-table-array-of-objects.png"></p>

<pre class="brush: js">// an object whose properties are objects

var family = {};

family.mother = new Person("Jane", "Smith");
family.father = new Person("John", "Smith");
family.daughter = new Person("Emily", "Smith");

console.table(family);</pre>

<p><img alt="Table displaying object of objects" src="https://mdn.mozillademos.org/files/8565/console-table-object-of-objects.png"></p>

<h3 id="Restricting_the_columns_displayed">Restricting the columns displayed</h3>

<p>By default, <code>console.table()</code> lists all elements in each row. You can use the optional <code>columns</code> parameter to select a subset of columns to display:</p>

<pre class="brush: js">// an array of objects, logging only firstName

function Person(firstName, lastName) {
  this.firstName = firstName;
  this.lastName = lastName;
}

var john = new Person("John", "Smith");
var jane = new Person("Jane", "Doe");
var emily = new Person("Emily", "Jones");

console.table([john, jane, emily], ["firstName"]);</pre>

<p><img alt="Table displaying array of objects with filtered output" src="https://mdn.mozillademos.org/files/8569/console-table-array-of-objects-firstName-only.png"></p>

<h3 id="Sorting_columns">Sorting columns</h3>

<p>You can sort the table by a particular column by clicking on that column's label.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox">console.table(data [, <em>columns</em>]);
</pre>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt><code>data</code></dt>
 <dd>The data to display. This must be either an array or an object.</dd>
 <dt><code>columns</code></dt>
 <dd>An array containing the names of columns to include in the output.</dd>
</dl>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName("Console API", "#table", "console.table()")}}</td>
   <td>{{Spec2("Console API")}}</td>
   <td>Initial definition</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div>

<p>{{Compat("api.Console.table")}}</p>
</div>
